<!DOCTYPE html>
<html lang="en">

<head>
  <title>Mapeo de Problemáticas Sociales con Perspectiva de Género</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="apple-touch-icon" href="assets/img/apple-icon.png">
  <link rel="shortcut icon" type="image/x-icon" href="assets/img/favicon.ico">

  <!-- Load Require CSS -->
  <link href="assets/css/bootstrap.min.css" rel="stylesheet">

  <!-- Font CSS -->
  <link href="assets/css/boxicon.min.css" rel="stylesheet">
  <link href="https://fonts.googleapis.com/css2?family=Open+Sans:wght@300;400;600&display=swap" rel="stylesheet">

  <!-- Load Template CSS -->
  <link rel="stylesheet" href="assets/css/templatemo.css">

  <!-- Custom CSS -->
  <link rel="stylesheet" href="assets/css/custom.css">
  <link rel="stylesheet" href="assets/css/mapa.css" />
  <link href="//netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
  <link href='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.css' rel='stylesheet' />

  <!-- Scripts -->
  <script src="assets/js/jquery.min.js"></script>
  <script src="assets/js/jquery.scrolly.min.js"></script>
  <script src="assets/js/skel.min.js"></script>
  <script src="assets/js/util.js"></script>
  <script src="assets/js/main.js"></script>
  <script src='https://api.mapbox.com/mapbox-gl-js/v1.12.0/mapbox-gl.js'></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.0/jquery.min.js"></script>
  <script src='https://npmcdn.com/csv2geojson@latest/csv2geojson.js'></script>
  <script src='https://npmcdn.com/@turf/turf/turf.min.js'></script>
</head>

<body>

  <!-- Header -->
  <nav id="main_nav" class="navbar navbar-expand-lg navbar-light bg-nav shadow">
    <div class="container d-flex justify-content-between align-items-center">
      <a class="navbar-brand h1" href="index.html">
        <img src="assets/img/logohorizontalunmdp.png" alt="logo" class="logo">
        <img src="assets/img/FCSyTS.png" alt="logo" class="logo">
        <img src="assets/img/logo-ests.png" alt="logo" class="logo">
      </a>
      <button class="navbar-toggler border-0" type="button" data-bs-toggle="collapse"
        data-bs-target="#navbar-toggler-success" aria-controls="navbarSupportedContent" aria-expanded="false"
        aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="align-self-center collapse navbar-collapse flex-fill  d-lg-flex justify-content-lg-between"
        id="navbar-toggler-success">
        <div class="flex-fill mx-xl-5 mb-2">

        </div>
        <div class="navbar d-flex">
          <img class="img-nav" src="assets/img/linea.svg">
          <a class="nav-link" href="https://www.facebook.com/extension.saludunmdp"><i
              class='bx bxl-facebook bx-sm '></i></a>
          <a class="nav-link" href="https://www.instagram.com/extension_salud_ts_unmdp/"><i
              class='bx bxl-instagram bx-sm'></i></a>
          <a class="nav-link" href="https://www.youtube.com/channel/UCDymj5hQy5aCnTU_lVdJ7jg"><i
              class='bx bxl-youtube bx-sm '></i></a>
          <a class="nav-link" href="mailto:extsalud@mdp.edu.ar"><i class='bx bx-envelope bx-sm '></i></a>
        </div>
      </div>
    </div>
  </nav>
  <!-- Close Header -->

<div id="map"></div>

<script>
	mapboxgl.accessToken = 'pk.eyJ1IjoiY3R5bmlrIiwiYSI6ImNrYzVnYWhteTA0emgyenFlbm5wcTdycHQifQ.ZGev0i_HerXEBNzYsYo9ag';
        var map = new mapboxgl.Map({
        container: 'map',
        style: 'mapbox://styles/mapbox/streets-v11',
        center: [-57.58681, -38.01965],
        zoom: 4
    });

    // Función para mostrar texto desde popup
      	function mostrarTexto() {
      		var popup = document.getElementById("myPopup");
      		popup.classList.toggle("show");
    	}
   
    // Función para cambiar la url y mostrar la imagen en el pop up 
   	function getLinkImagen(link) {
              var aux = "https://drive.google.com/uc?export=view&id=";
              aux = aux + link;
              return aux
        }

    $(document).ready(function () {
      $.ajax({
        type: "GET",
        //YOUR TURN: Replace with csv export link
        url: 'https://docs.google.com/spreadsheets/d/11lYtDR1BFN_UGbuBEBHIbv9K8MLSB7HoD-VpS3SlOu8/gviz/tq?tqx=out:csv&sheet=PSPG',
        dataType: "text",
        success: function (csvData) { makeGeoJSON(csvData); }
      });

      function makeGeoJSON(csvData) {
        csv2geojson.csv2geojson(csvData, {
          latfield: 'Latitud',
          lonfield: 'Longitud',
          delimiter: ','
        }, function (err, data) {
          map.on('load', function () {
        // Add a new source from our GeoJSON data and
        // set the 'cluster' option to true. GL-JS will
        // add the point_count property to your source data.

        map.addSource('proyectos', {
            type: 'geojson',
            data: data,
           // data: 'assets/geojson/pspg.geojson', //linea para traer las coordenadas desde archivo
            cluster: true,
            clusterMaxZoom: 14, // Max zoom to cluster points on
            clusterRadius: 50 // Radius of each cluster when clustering points (defaults to 50)
        });

        // Agrega las imágenes de los íconos
            map.loadImage(
              './assets/iconos/1.alimentación.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('alimentacion', image);
              });
            map.loadImage(
              './assets/iconos/2.trabajo.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('trabajo', image);
              });
            map.loadImage(
              './assets/iconos/3.violencia-por-motivos-de-género.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('genero', image);
              });
            map.loadImage(
              './assets/iconos/4.salud.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('salud', image);
              });
            map.loadImage(
              './assets/iconos/5.educación.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('educacion', image);
              });
            map.loadImage(
              './assets/iconos/6.vivienda.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('vivienda', image);
              });
            map.loadImage(
              './assets/iconos/7.servicios.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('servicios', image);
              });
            map.loadImage(
              './assets/iconos/8.problematicas-socioambientales.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('problematicas-socioambientales', image);
              });
            map.loadImage(
              './assets/iconos/9.acceso-a-la-justicia.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('acceso-a-la-justicia', image);
              });
            map.loadImage(
              './assets/iconos/10.violencia-policial.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('violencia-policial', image);
              });
            map.loadImage(
              './assets/iconos/11.cuidados.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('cuidados', image);
              });
            map.loadImage(
              './assets/iconos/12.acceso-a-la-cultura.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('cultura', image);
              });
            map.loadImage(
              './assets/iconos/13.acceso-a-la-identidad.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('identidad', image);
              });
            map.loadImage(
              './assets/iconos/14.personas-mayores.png',
              // Add an image to use as a custom marker
              function (error, image) {
                if (error) throw error;
                map.addImage('mayores', image);
              });

	// disable map rotation using right click + drag
            map.dragRotate.disable();
	// disable map rotation using touch rotation gesture
            map.touchZoomRotate.disableRotation();
	// Add zoom and rotation controls to the map.
            map.addControl(new mapboxgl.NavigationControl(), 'top-left');
        // Add fullscreen control to the map.
            map.addControl(new mapboxgl.FullscreenControl(), 'top-left');

       map.addLayer({
            id: 'clusters',
            type: 'circle',
            source: 'proyectos',
            filter: ['has', 'point_count'],
            paint: {
                'circle-color': '#d3d0dc',
                'circle-radius': 15,
                'circle-stroke-width': 4,
                'circle-stroke-color': '#3f377c'
            }
        });

        map.addLayer({
            id: 'cluster-count',
            type: 'symbol',
            source: 'proyectos',
            filter: ['has', 'point_count'],
            layout: {
                'text-field': '{point_count_abbreviated}',
                'text-font': ['DIN Offc Pro Medium', 'Arial Unicode MS Bold'],
                'text-size': 12
            }
        });

        map.addLayer({
            id: 'unclustered-point',
            type: 'circle',
            source: 'proyectos',
            filter: ['!', ['has', 'point_count']],
            paint: {
                    'circle-color': '#822882',
                   }
        });

            map.addLayer({
               id: 'iconos',
	       type: 'symbol',
               source: 'proyectos',
               filter: ['!', ['has', 'point_count']],
	       layout: {
		// reference the image
		'icon-image': ['match',
			['get', 'Problematica'],
			'Acceso a la alimentación', 'alimentacion',// 
			'Acceso al trabajo', 'trabajo', //
			'Violencia por motivos de género', 'genero',//
			'Acceso a la salud', 'salud',//
			'Acceso a la educación', 'educacion',
			'Acceso a la vivienda digna', 'vivienda',
			'Acceso a los servicios básicos en el barrio', 'servicios',
			'Problemáticas socio-ambientales', 'problematicas-socioambientales',
			'Acceso a la justicia', 'acceso-a-la-justicia',
			'Violencia policial', 'violencia-policial',
			'Acceso a los cuidados ("guarderías", jardines, instituciones de residencia, centros de día, otros)', 'cuidados',
			'Acceso a cultura, deporte y/o recreación', 'cultura',//
			'Acceso a la identidad', 'identidad',
			'Discriminación y maltratos por razones de edad', 'mayores',
			'trabajo'],
			'icon-size': 0.75
			},
		minzoom: 7,
	});


        // inspect a cluster on click
        map.on('click', 'clusters', (e) => {
            const features = map.queryRenderedFeatures(e.point, {
                layers: ['clusters']
            });
            const clusterId = features[0].properties.cluster_id;
            map.getSource('proyectos').getClusterExpansionZoom(
                clusterId,
                (err, zoom) => {
                    if (err) return;

                    map.easeTo({
                        center: features[0].geometry.coordinates,
                        zoom: zoom
                    });
                }
            );
        });


   	  // When a click event occurs on a feature in the csvData layer, open a popup at the
          // location of the feature, with description HTML from its properties.
            map.on('click', 'iconos', function (e) {
              var coordinates = e.features[0].geometry.coordinates.slice();
              var linkImg;
              if (e.features[0].properties.Imagen.split("/").length == 7) {
                linkImg = getLinkImagen(e.features[0].properties.Imagen.split("/")[5]);
              }
              else {
                linkImg = getLinkImagen(e.features[0].properties.Imagen.split("id=")[1]);
              }
              //set popup text 
              //You can adjust the values of the popup to match the headers of your CSV. 
              // For example: e.features[0].properties.Name is retrieving information from the field Name in the original CSV. 
 
              var description = '<h5>' + e.features[0].properties.Intervencion + '</h5>' + '<img src="' + linkImg + '" width="280">' + '<h4>' + '<b>' + 'Barrio: ' + '</b>' + e.features[0].properties.Barrio + '</h4>' + '<h4>' + '<b>' + 'Tipo de espacio/organización: ' + '</b>' + e.features[0].properties.Tipo + '</h4>' + '<h4>' + '<b>' + 'Principal problemática: ' + '</b>' + e.features[0].properties.Problematica + '</h4>' + '<h5>' + '<a href="' + e.features[0].properties.Audio + '" target="_blank" > Audio</a>' + ' | ' + '<div class="popup" onclick="mostrarTexto()"><a> Resultados</a><span class="popuptext" id="myPopup">' + e.features[0].properties.Resultados + '</span></div>' + ' | ' + '<a href="' + e.features[0].properties.Contacto + '" target="_blank" > Contacto</a>' + '</h5>';

            // Ensure that if the map is zoomed out such that
            // multiple copies of the feature are visible, the
            // popup appears over the copy being pointed to.
            while (Math.abs(e.lngLat.lng - coordinates[0]) > 180) {
                coordinates[0] += e.lngLat.lng > coordinates[0] ? 360 : -360;
            }

            // esto es solo por si no hay enlace a redes definido
            if (e.features[0].properties.enlace == null || e.features[0].properties.enlace == undefined) {
                console.log("El enlace es NULL o no está definido");
            }
             
            new mapboxgl.Popup()
                .setLngLat(coordinates)
                .setHTML(description)
                .addTo(map);
        });

        map.on('mouseenter', 'iconos', function () {
            map.getCanvas().style.cursor = 'pointer';
        });
        map.on('mouseleave', 'iconos', function () {
            map.getCanvas().style.cursor = '';
        });
        map.on('mouseenter', 'clusters', function () {
            map.getCanvas().style.cursor = 'pointer';
        });
        map.on('mouseleave', 'clusters', function () {
            map.getCanvas().style.cursor = '';
        });
        var bbox = turf.bbox(data);
        map.fitBounds(bbox, { padding: 150 });
        });

        });
      };
    });


  </script>

</body>
</html>
